module Encoding.Morse 
  ( encmorse
  , decmorse
  ) where

import Text.Morse as M
import Data.ByteString (ByteString)
import qualified Data.ByteString.Char8 as BC

encmorse :: ByteString -> ByteString
encmorse input = BC.pack $ encodeValidMorseChars (BC.unpack input)
  where
    encodeValidMorseChars :: String -> String
    encodeValidMorseChars = concatMap (\c -> if canEncodeToMorse c then M.encodeMorse [c] else "")

decmorse :: ByteString -> ByteString
decmorse input = case M.decodeMorse (BC.unpack input) of
                   "" -> BC.pack "Invalid Morse Code"
                   decoded -> BC.pack decoded

